searchNodes=[{"type":"task","title":"Mix.Tasks.StatesLanguage.D3","doc":"Outputs a binary version of the D3 serialization suitable for writing to a file","ref":"Mix.Tasks.StatesLanguage.D3.html"},{"type":"function","title":"Mix.Tasks.StatesLanguage.D3.run/1","doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.StatesLanguage.D3.html#run/1"},{"type":"task","title":"Mix.Tasks.StatesLanguage.Dot","doc":"Outputs a binary version of the Dot format suitable for writing to a file","ref":"Mix.Tasks.StatesLanguage.Dot.html"},{"type":"function","title":"Mix.Tasks.StatesLanguage.Dot.run/1","doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.StatesLanguage.Dot.html#run/1"},{"type":"behaviour","title":"StatesLanguage","doc":"A macro to parse StatesLanguage JSON and create :gen_statem modules","ref":"StatesLanguage.html"},{"type":"callback","title":"StatesLanguage.handle_call/4","doc":"Called when a call event has been received. It is up to your implentation to return {:reply, from, result} to send the result back to the caller. Arguments event: the payload sent with the call from: used to reply to the caller state: the current state data: the full data of the :gen_statem process","ref":"StatesLanguage.html#c:handle_call/4"},{"type":"callback","title":"StatesLanguage.handle_cast/3","doc":"Called when a cast event has been received. Arguments event: the payload sent with the cast state: the current state data: the full data of the :gen_statem process","ref":"StatesLanguage.html#c:handle_cast/3"},{"type":"callback","title":"StatesLanguage.handle_enter/3","doc":"Called when we enter a new state, but before any additional actions have occurred. Arguments old_state: The previous state we were in state: the current state data: the full data of the :gen_statem process","ref":"StatesLanguage.html#c:handle_enter/3"},{"type":"callback","title":"StatesLanguage.handle_event_timeout/3","doc":"Called when a Event Timeout is triggered. Arguments event: The event set for the timeout state: the current state data: the full data of the :gen_statem process","ref":"StatesLanguage.html#c:handle_event_timeout/3"},{"type":"callback","title":"StatesLanguage.handle_generic_timeout/3","doc":"Called when a Generic Timeout is triggered. Arguments event: The event set for the timeout state: the current state data: the full data of the :gen_statem process","ref":"StatesLanguage.html#c:handle_generic_timeout/3"},{"type":"callback","title":"StatesLanguage.handle_info/3","doc":"Called when something has sent an event to our process. Arguments event: the event that was sent to us state: the current state data: the full data of the :gen_statem process","ref":"StatesLanguage.html#c:handle_info/3"},{"type":"callback","title":"StatesLanguage.handle_resource/4","doc":"Called when a Choice or Task state is transitioned to. Arguments resource: The value of the Resource field for this state params: the data after applying any JSONPath selectors to our data attribute state: the current state data: the full data of the :gen_statem process","ref":"StatesLanguage.html#c:handle_resource/4"},{"type":"callback","title":"StatesLanguage.handle_state_timeout/3","doc":"Called when a State Timeout is triggered. Arguments event: The event set for the timeout state: the current state data: the full data of the :gen_statem process","ref":"StatesLanguage.html#c:handle_state_timeout/3"},{"type":"callback","title":"StatesLanguage.handle_termination/3","doc":"Called when a process is ending. This can be because it was killed or a state indicated it's the end of the state machine. Used for cleanup. Arguments reason: the reason we are ending eg; :normal , :kill , etc. state: the current state data: the full data of the :gen_statem process","ref":"StatesLanguage.html#c:handle_termination/3"},{"type":"callback","title":"StatesLanguage.handle_transition/3","doc":"Called when a transition event has been received, but before we transition to the next state. Arguments event: The transition event received state: the current state data: the full data of the :gen_statem process","ref":"StatesLanguage.html#c:handle_transition/3"},{"type":"function","title":"StatesLanguage.validate/1","doc":"Validates our graph data against the included JSON Schema. This is run automatically at compilation time.","ref":"StatesLanguage.html#validate/1"},{"type":"type","title":"StatesLanguage.callback_result/0","doc":"All callbacks are expected to return a tuple containing an updated (if necessary) StatesLanguage.t/0 , and a list of actions to perform after the callback has exectuted. A default callback that doesn't need to do anything would just return {:ok, data, []}","ref":"StatesLanguage.html#t:callback_result/0"},{"type":"type","title":"StatesLanguage.t/0","doc":"Passed to all processes as the data for the :gen_statem.data . _parent is used to reference a parent process within a Map or Parallel state type _parent_data is the data from the parent data is the data passed to this process on startup _tasks is used to keep track of child processes for Map and Parallel state types","ref":"StatesLanguage.html#t:t/0"},{"type":"type","title":"StatesLanguage.task_processed/0","doc":"When using the &quot;Parallel&quot; or &quot;Map&quot; types, the children processes must send/2 a message to the parent process of this type. The child_process pid is the pid/0 of the child spawned by the parent state machine, generally the same as calling self/0 in the child process itself.","ref":"StatesLanguage.html#t:task_processed/0"},{"type":"module","title":"StatesLanguage.Catch","doc":"Represents a catch error in a Task type state","ref":"StatesLanguage.Catch.html"},{"type":"type","title":"StatesLanguage.Catch.t/0","doc":"","ref":"StatesLanguage.Catch.html#t:t/0"},{"type":"module","title":"StatesLanguage.Choice","doc":"Represents a choice option in a Choice type state","ref":"StatesLanguage.Choice.html"},{"type":"type","title":"StatesLanguage.Choice.t/0","doc":"","ref":"StatesLanguage.Choice.html#t:t/0"},{"type":"module","title":"StatesLanguage.Edge","doc":"Represents a transition from one state to another","ref":"StatesLanguage.Edge.html"},{"type":"type","title":"StatesLanguage.Edge.t/0","doc":"","ref":"StatesLanguage.Edge.html#t:t/0"},{"type":"module","title":"StatesLanguage.Graph","doc":"Functions for creating a Graph structure from deserialized JSON. This is used by Serializers and the core library. See StatesLanguage.Serializer.D3Graph .","ref":"StatesLanguage.Graph.html"},{"type":"function","title":"StatesLanguage.Graph.escape_string/1","doc":"","ref":"StatesLanguage.Graph.html#escape_string/1"},{"type":"function","title":"StatesLanguage.Graph.get_edges/1","doc":"","ref":"StatesLanguage.Graph.html#get_edges/1"},{"type":"function","title":"StatesLanguage.Graph.serialize/1","doc":"","ref":"StatesLanguage.Graph.html#serialize/1"},{"type":"type","title":"StatesLanguage.Graph.t/0","doc":"","ref":"StatesLanguage.Graph.html#t:t/0"},{"type":"module","title":"StatesLanguage.JSONPath","doc":"Functions for handling JSONPath support","ref":"StatesLanguage.JSONPath.html"},{"type":"function","title":"StatesLanguage.JSONPath.generate_parameters/2","doc":"","ref":"StatesLanguage.JSONPath.html#generate_parameters/2"},{"type":"function","title":"StatesLanguage.JSONPath.get_parameters/3","doc":"","ref":"StatesLanguage.JSONPath.html#get_parameters/3"},{"type":"function","title":"StatesLanguage.JSONPath.put_path/3","doc":"","ref":"StatesLanguage.JSONPath.html#put_path/3"},{"type":"function","title":"StatesLanguage.JSONPath.put_result/4","doc":"","ref":"StatesLanguage.JSONPath.html#put_result/4"},{"type":"function","title":"StatesLanguage.JSONPath.run_json_path/2","doc":"","ref":"StatesLanguage.JSONPath.html#run_json_path/2"},{"type":"module","title":"StatesLanguage.Node","doc":"Represents any state in our graph","ref":"StatesLanguage.Node.html"},{"type":"type","title":"StatesLanguage.Node.t/0","doc":"","ref":"StatesLanguage.Node.html#t:t/0"},{"type":"module","title":"StatesLanguage.Serializer.D3Graph","doc":"Serialize a StatesLanguage.Graph into a suitable graph structure for D3.","ref":"StatesLanguage.Serializer.D3Graph.html"},{"type":"function","title":"StatesLanguage.Serializer.D3Graph.serialize/1","doc":"","ref":"StatesLanguage.Serializer.D3Graph.html#serialize/1"},{"type":"module","title":"StatesLanguage.Serializer.Dot","doc":"Serializer for StatesLanguage.Graph to Graphviz compatible .dot file","ref":"StatesLanguage.Serializer.Dot.html"},{"type":"function","title":"StatesLanguage.Serializer.Dot.serialize/1","doc":"","ref":"StatesLanguage.Serializer.Dot.html#serialize/1"},{"type":"extras","title":"StatesLanguage","doc":"StatesLanguage Declaratively design state machines that compile to Elixir based :gen_statem processes with the States Language JSON specification.","ref":"readme.html"},{"type":"extras","title":"StatesLanguage - About","doc":"States Language is the JSON specification behind AWS Step Functions , a powerful way to coordinate many disparate services into a cohesive &quot;serverless&quot; system. This library uses the same JSON specification and compiles to Elixir based gen_statem processes. The initial idea for the Elixir implementation came about while working on an IVR system and we wanted a way to describe &quot;call flows&quot; in a declarative manner. Ideally building a system on top to allow for solution engineers to visually build call flows for a client, without writing any code. After researching the space a bit, we landed on the States Language spec and decided it was a great fit for describing state machines. With the power of Elixir macros in-hand, this library was born.","ref":"readme.html#about"},{"type":"extras","title":"StatesLanguage - Getting Started","doc":"Adding StatesLanguage to your project Add StatesLanguage as a dependency to your mix.exs file. defp deps do [ { :states_language , &quot;~&gt; 0.2.3&quot; } ] end","ref":"readme.html#getting-started"},{"type":"extras","title":"StatesLanguage - Usage","doc":"For those unfamiliar with state machines, a vending machine is an often used example, so we're going to stick with that for our walk-through of how to use this library. For a more detailed description of state machines see the wikipedia article . For the sake of brevity, we're alo going to assume that the vending machine has already accepted the money and is now waiting for someone to hit the correct buttons in the correct order to dispense the nosh. Nosh A snack or light meal. Let's start with a diagram of our system. There's only a few states to deal with here, so let's get started. Let's start by creating the States Language JSON description, name it vending_machine.json { &quot;Comment&quot;: &quot;Dispense with the nosh&quot;, &quot;StartAt&quot;: &quot;AcceptInput&quot;, &quot;States&quot;: { &quot;AcceptInput&quot;: { &quot;Type&quot;: &quot;Task&quot;, &quot;Resource&quot;: &quot;StartKeyPad&quot;, &quot;TransitionEvent&quot;: &quot;%{event: :input_received}&quot;, &quot;Next&quot;: &quot;DoLookup&quot; }, &quot;DoLookup&quot;: { &quot;Type&quot;: &quot;Task&quot;, &quot;Resource&quot;: &quot;DoLookup&quot;, &quot;TransitionEvent&quot;: &quot;:success&quot;, &quot;InputPath&quot;: &quot;$.:keypad&quot;, &quot;Parameters&quot;: { &quot;keyed_input.$&quot;: &quot;$.:input&quot; }, &quot;Next&quot;: &quot;DispenseNosh&quot;, &quot;Catch&quot;: [ { &quot;ErrorEquals&quot;: [&quot;:invalid_lookup&quot;], &quot;Next&quot;: &quot;InvalidLookupError&quot; }, { &quot;ErrorEquals&quot;: [&quot;:network_error&quot;], &quot;Next&quot;: &quot;NetworkError&quot; } ] }, &quot;NetworkError&quot;: { &quot;Type&quot;: &quot;Task&quot;, &quot;Resource&quot;: &quot;SetError:Network Error. Please try again&quot;, &quot;Next&quot;: &quot;ShowError&quot; }, &quot;InvalidLookupError&quot;: { &quot;Type&quot;: &quot;Task&quot;, &quot;Resource&quot;: &quot;SetError:That was not a correct nosh code, please try again&quot;, &quot;Next&quot;: &quot;ShowError&quot; }, &quot;ShowError&quot;: { &quot;Type&quot;: &quot;Task&quot;, &quot;Resource&quot;: &quot;DisplayText:error&quot;, &quot;Next&quot;: &quot;AcceptInput&quot; }, &quot;DispenseNosh&quot;: { &quot;Type&quot;: &quot;Task&quot;, &quot;Resource&quot;: &quot;DispenseNosh&quot;, &quot;End&quot;: true } } }","ref":"readme.html#usage"},{"type":"extras","title":"StatesLanguage - State Fields","doc":"We can see each state from our diagram represented, and a few mentions of &quot;TransitionEvent&quot;. You can see that those events look eerily like Elixir maps and atoms. The library will evaluate these strings into their Elixir equivalent to do some fun pattern matching. One thing to note is that we can't use ambiguous matching, we have to be explicit. For example, in our AcceptInput transition event, we couldn't do something like %{event: my_event} . It has to be an atom or something that can be evaluated at compile time %{event: :clicked} , string, integer, etc. TransitionEvent You may notice that a few of our states are without the TransitionEvent field. The library will provide a default transition event of :transition . We'll see more about that when we go over the Elixir code that implements our machine. It's worth noting that TransitionEvent isn't in the States Language spec , but I've found it quite a powerful addition. For example, this allows external processes to send events to the state machine, without us having to write listener/translation code for every possible event. We just say, when you receive this event, transition to the next state. Note The mix of JSON decoding and Code.eval_string makes it a bit tricky to use just a plain string as an event, however it is possible. In your JSON file, you can use a sigil and escaped string like so &quot;TransitionEvent&quot;: &quot;\\&quot;~s(my_event)\\&quot;&quot; . Resource The Resource field is where we tell the state machine what &quot;function&quot; to call when we enter that state, the &quot;Resource&quot; is also what's responsible for telling the state machine to transition, returning {:next_event, :internal, :transition} or whatever we've declared our transition event to be, or not, transition events can come from anywhere. Since under the hood we are using :gen_statem we can return whatever actions are supported by it, timeouts, postpone, hibernate etc. The :gen_statem docs for actions can be very helpful. Type The Type field is very important. This tells us what type of state we are, and each one gets processed a bit different. Currently supported types are Task , Map , Parallel , Choice and Wait . The spec does list a few other types, Pass , Fail and Succeed types. The &quot;Map&quot; and &quot;Parallel&quot; types differ a bit from the spec, for the Elixir version, we actually set the branch or iterator to a module name, rather than putting the embedded logic in the parent state machine. You can check out the JSON for those tests here . See the guides for an example of using the Map type. Next The Next field is pretty self-explanatory. Upon receiving a TransitionEvent event or :transition it transitions the state machine to the next state. Catch The Catch field allows us to &quot;catch&quot; errors and move to an error state. The same principles apply to these events as with our transition events, must be able to evaluate at compile time. Notice that ErrorEquals is an array, so it's possible to list multiple error events and transition to the same state. Catch itself is also an array, so you can transition to multiple states depending on the type of error. I find this useful for states that may be reaching out to external resources and there are several possible failure modes. End End is another self-explantory field. After processing the Resource no matter what the result, we :stop the :gen_statem process. The handle_termination/3 callback will be called for final cleanup.","ref":"readme.html#state-fields"},{"type":"extras","title":"StatesLanguage - JSONPath","doc":"InputPath , Parameters , ResourcePath and OutputPath all use JSONPath to mutate the incoming and outgoing data. InputPath InputPath is used to select a field from the incoming data, they can be atom keys or string keys, as well as array indexes such as [1] . For atom keys, you need to prepend the key with : for strings, just the key name. Parameters Parameters allow you to pass in default values as well as select data from the InputPath selection. It's worth noting that if none of the paths are provided they default to $ which essentially just passes the incoming data to the resource untouched. ResourcePath ResourcePath allows you to select keys or array indexes from the result to pass to the next state. OutputPath OutputPath will create new nested keys in the result to pass to the next state. In practice we don't generally use the path support often and instead just pass a struct through to each state, building up our data (state) as we move through each state, this is similar to how Plug uses the connection struct. The path support is definitely helpful when talking to external services that you don't control, and the output of one resource needs to be mutated into a different structure for the next resource.","ref":"readme.html#jsonpath"},{"type":"extras","title":"StatesLanguage - State Machine Module","doc":"Now let's create our module implementation, name it vending_machine.ex . Note If you are following along by creating your own mix project, you'll need to update the @external_resource and data variables on lines 2 and 3, to point to the JSON file you created above. defmodule VendingMachine do use StatesLanguage , data : &quot;test/support/vending_machine.json&quot; defmodule Data do defstruct keypad : %{ input : &quot;&quot; } , lookup : %{ result : nil } , error : &quot;&quot; , test : nil end @impl true def handle_resource ( &quot;StartKeyPad&quot; , _params , &quot;AcceptInput&quot; , % StatesLanguage { } = sl ) do me = self ( ) # Let&#39;s pretend someone is pushing keys, see the `handle_info` callback below for how these are handled. Task . start ( fn -&gt; send ( me , { :keypress , &quot;a&quot; } ) send ( me , { :keypress , &quot;1&quot; } ) send ( me , { :keypress , &quot;2&quot; } ) send ( me , { :keypress , &quot;3&quot; } ) end ) { :ok , sl , [ ] } end @impl true def handle_resource ( &quot;DoLookup&quot; , %{ &quot;keyed_input&quot; = &gt; code } , &quot;DoLookup&quot; , % StatesLanguage { data : % Data { } = data } = sl ) do debug ( &quot;Looking up code \#{ code } &quot; ) { data , actions } = case lookup ( code ) do { :ok , result } -&gt; { % Data { data | lookup : %{ result : result } } , [ { :next_event , :internal , :success } ] } { :error , :network } -&gt; { data , [ { :next_event , :internal , :network_error } ] } { :error , :no_result } -&gt; { data , [ { :next_event , :internal , :lookup_error } ] } end { :ok , % StatesLanguage { sl | data : data } , actions } end @impl true def handle_resource ( &lt;&lt; &quot;SetError:&quot; , error :: binary &gt;&gt; , _params , _any_state , % StatesLanguage { data : % Data { } = data } = sl ) do { :ok , % StatesLanguage { sl | data : % Data { data | error : error } } , [ { :next_event , :internal , :transition } ] } end @impl true def handle_resource ( &lt;&lt; &quot;DisplayText:&quot; , key :: binary &gt;&gt; , _params , &quot;ShowError&quot; , % StatesLanguage { data : % Data { } = data } = sl ) do key = String . to_existing_atom ( key ) text = Map . get ( data , key ) Logger . info ( &quot;Displaying Text: \#{ text } &quot; ) { :ok , sl , [ { :next_event , :internal , :transition } ] } end @impl true def handle_resource ( &quot;DispenseNosh&quot; , _params , &quot;DispenseNosh&quot; , % StatesLanguage { data : % Data { } = data } = sl ) do Logger . info ( &quot;Dispensing one \#{ inspect ( data . lookup . result . candy ) } &quot; ) { :ok , sl , [ ] } end @impl true def handle_info ( { :keypress , digit } , &quot;AcceptInput&quot; , % StatesLanguage { data : % Data { } = data } = sl ) do input = data . keypad . input input = input &lt;&gt; digit actions = if String . length ( input ) &gt; 3 do [ { :next_event , :internal , %{ event : :input_received } } ] else [ ] end { :ok , % StatesLanguage { sl | data : % Data { data | keypad : %{ input : input } } } , actions } end @impl true def handle_termination ( _ , _ , % StatesLanguage { data : % Data { } = data } ) do send ( data . test , :finished ) :ok end defp lookup ( 1_234_556 ) , do : { :error , :no_result } defp lookup ( 11_111_111 ) , do : { :error , :network } defp lookup ( _code ) do { :ok , %{ candy : &quot;Snickers&quot; } } end end If you've checked out the StatesLanguage repo, you can run this code by running $ MIX_ENV=test mix test test/states_language_vending_machine_test.exs --force from your CLI. If you are building your own project you can run it like this. $ iex -S mix iex(1)&gt; VendingMachine.start_link(%VendingMachine.Data{test: self()}) iex(2)&gt; flush() :finished :ok Which should result in output that looks like this. $ MIX_ENV=test mix test test/states_language_vending_machine_test.exs --force Compiling 14 files (.ex) Generated states_language app 14:41:21.827 [debug] Elixir.VendingMachine - Init: Data - %VendingMachine.Data{error: &quot;&quot;, keypad: %{input: &quot;&quot;}, lookup: %{result: nil}, test: #PID&lt;0.285.0&gt;} Actions - [{:next_event, :internal, :handle_resource}] 14:41:21.828 [debug] Elixir.VendingMachine - left &quot;AcceptInput&quot; --&gt; &quot;AcceptInput&quot;: %StatesLanguage{_parent: nil, _parent_data: nil, _supervisor: nil, _tasks: [], data: %VendingMachine.Data{error: &quot;&quot;, keypad: %{input: &quot;&quot;}, lookup: %{result: nil}, test: #PID&lt;0.285.0&gt;}} 14:41:21.833 [debug] Elixir.VendingMachine - Handled info event: {:keypress, &quot;a&quot;} in state AcceptInput with data %StatesLanguage{_parent: nil, _parent_data: nil, _supervisor: nil, _tasks: [], data: %VendingMachine.Data{error: &quot;&quot;, keypad: %{input: &quot;a&quot;}, lookup: %{result: nil}, test: #PID&lt;0.285.0&gt;}} 14:41:21.833 [debug] Elixir.VendingMachine - Handled info event: {:keypress, &quot;1&quot;} in state AcceptInput with data %StatesLanguage{_parent: nil, _parent_data: nil, _supervisor: nil, _tasks: [], data: %VendingMachine.Data{error: &quot;&quot;, keypad: %{input: &quot;a1&quot;}, lookup: %{result: nil}, test: #PID&lt;0.285.0&gt;}} 14:41:21.833 [debug] Elixir.VendingMachine - Handled info event: {:keypress, &quot;2&quot;} in state AcceptInput with data %StatesLanguage{_parent: nil, _parent_data: nil, _supervisor: nil, _tasks: [], data: %VendingMachine.Data{error: &quot;&quot;, keypad: %{input: &quot;a12&quot;}, lookup: %{result: nil}, test: #PID&lt;0.285.0&gt;}} 14:41:21.833 [debug] Elixir.VendingMachine - Handled info event: {:keypress, &quot;3&quot;} in state AcceptInput with data %StatesLanguage{_parent: nil, _parent_data: nil, _supervisor: nil, _tasks: [], data: %VendingMachine.Data{error: &quot;&quot;, keypad: %{input: &quot;a123&quot;}, lookup: %{result: nil}, test: #PID&lt;0.285.0&gt;}} 14:41:21.833 [debug] Elixir.VendingMachine - got internal event %{event: :input_received} in state &quot;AcceptInput&quot; transitioning to &quot;DoLookup&quot; 14:41:21.833 [debug] Elixir.VendingMachine - left &quot;AcceptInput&quot; --&gt; &quot;DoLookup&quot;: %StatesLanguage{_parent: nil, _parent_data: nil, _supervisor: nil, _tasks: [], data: %VendingMachine.Data{error: &quot;&quot;, keypad: %{input: &quot;a123&quot;}, lookup: %{result: nil}, test: #PID&lt;0.285.0&gt;}} 14:41:21.862 [debug] Elixir.VendingMachine - Looking up code a123 14:41:21.862 [debug] Elixir.VendingMachine - got internal event :success in state &quot;DoLookup&quot; transitioning to &quot;DispenseNosh&quot; 14:41:21.863 [debug] Elixir.VendingMachine - left &quot;DoLookup&quot; --&gt; &quot;DispenseNosh&quot;: %StatesLanguage{_parent: nil, _parent_data: nil, _supervisor: nil, _tasks: [], data: %VendingMachine.Data{error: &quot;&quot;, keypad: %{input: &quot;a123&quot;}, lookup: %{result: %{candy: &quot;Snickers&quot;}}, test: #PID&lt;0.285.0&gt;}} 14:41:21.863 [info] Dispensing one &quot;Snickers&quot; 14:41:21.863 [debug] Elixir.VendingMachine - Terminating in state DispenseNosh :normal","ref":"readme.html#state-machine-module"},{"type":"extras","title":"StatesLanguage - Persisting process state","doc":"It's also possible to override the &quot;Start&quot; state and perhaps pass in a deserialized data object. This would allow you to persist the StatesLanguage process to storage and restart the process where you left off. For the vending machine example you could pass in your data and a start parameter to start_link or start $ iex -S mix iex(1)&gt; data = %Data{test: self(), keypad: %{input: &quot;a123&quot;}, lookup: %{result: %{candy: &quot;Snickers&quot;}}} iex(2)&gt; VendingMachine.start_link(data, start: &quot;DispenseNosh&quot;) iex(3)&gt; flush() :finished :ok And your output would look something like this 09 : 19 : 04.239 [ debug ] Elixir.VendingMachine - Init : Data - % VendingMachine.Data { error : &quot;&quot; , keypad : %{ input : &quot;a123&quot; } , lookup : %{ result : %{ candy : &quot;Snickers&quot; } } , test : # PID &lt; 0 . 346 . 0 &gt; } 09 : 19 : 04.239 [ warn ] Unknown enter event from &quot;DispenseNosh&quot; to &quot;DispenseNosh&quot; 09 : 19 : 04.239 [ info ] Dispensing one &quot;Snickers&quot; 09 : 19 : 04.239 [ debug ] Elixir.VendingMachine - Terminating in state DispenseNosh :normal","ref":"readme.html#persisting-process-state"},{"type":"extras","title":"StatesLanguage - Validation","doc":"The library also includes JSON Schemas to validate that your state machines are valid States Language JSON data. Validation is automatically done at compile time, and will throw({:error, error_map}) if the data does not pass validation. The StatesLanguage library uses json_xema for validation. The schema files are available in priv/schemas It's useful to test your state machines in your test phase which is possible by calling StatesLanguage.validate(my_state_machine_map) The function expects a map, so make sure to deserialize your data first.","ref":"readme.html#validation"},{"type":"extras","title":"StatesLanguage - Serialization","doc":"One of the main benefits of describing your state machines in JSON is the interoperability of the format. This library is obviously all Elixir, but there are many use cases where you may want to share the state machine specification. Something like a visual editor. Mix Tasks There are 2 mix tasks included to quickly output serialized graphs for the Graphviz Dot format and the D3 Graph format. mix states_language.dot and mix states_language.d3 respectively. To quickly view a graph visually, assuming you have Graphviz installed with the dot program you can run this. $ mix states_language.dot test/support/vending_machine.json &gt; ~/Desktop/vending_machine.dot $ dot -Tpng ~/Desktop/vending_machine.dot -o ~/Desktop/vending_machine.png Which should result in a .png file that looks like this. Serializer Modules You can also use the serializers in your own applications. This example is using the StatesLanguage.Serializer.D3Graph to serialize the graph structure to something compatible with D3 and DagreD3 . The initial graph for our vending machine example looks like this. This is generated by calling StatesLanguage.Graph.serialize/1 % StatesLanguage.Graph { comment : &quot;Dispense with the nosh&quot; , edges : [ % StatesLanguage.Edge { event : { :%{} , [ ] , [ event : :input_received ] } , source : &quot;AcceptInput&quot; , target : &quot;DoLookup&quot; } , % StatesLanguage.Edge { event : :success , source : &quot;DoLookup&quot; , target : &quot;DispenseNosh&quot; } , % StatesLanguage.Edge { event : :invalid_lookup , source : &quot;DoLookup&quot; , target : &quot;InvalidLookupError&quot; } , % StatesLanguage.Edge { event : :network_error , source : &quot;DoLookup&quot; , target : &quot;NetworkError&quot; } , % StatesLanguage.Edge { event : :transition , source : &quot;InvalidLookupError&quot; , target : &quot;ShowError&quot; } , % StatesLanguage.Edge { event : :transition , source : &quot;NetworkError&quot; , target : &quot;ShowError&quot; } , % StatesLanguage.Edge { event : :transition , source : &quot;ShowError&quot; , target : &quot;AcceptInput&quot; } ] , nodes : %{ &quot;AcceptInput&quot; = &gt; % StatesLanguage.Node { branches : [ ] , catch : [ ] , choices : [ ] , default : nil , event : { :%{} , [ ] , [ event : :input_received ] } , input_path : &quot;$&quot; , is_end : false , items_path : nil , iterator : nil , next : &quot;DoLookup&quot; , output_path : &quot;$&quot; , parameters : { :%{} , [ ] , [ ] } , resource : &quot;StartKeyPad&quot; , resource_path : &quot;$&quot; , seconds : nil , seconds_path : nil , timestamp : nil , timestamp_path : nil , type : &quot;Task&quot; } , &quot;DispenseNosh&quot; = &gt; % StatesLanguage.Node { branches : [ ] , catch : [ ] , choices : [ ] , default : nil , event : :transition , input_path : &quot;$&quot; , is_end : true , items_path : nil , iterator : nil , next : nil , output_path : &quot;$&quot; , parameters : { :%{} , [ ] , [ ] } , resource : &quot;DispenseNosh&quot; , resource_path : &quot;$&quot; , seconds : nil , seconds_path : nil , timestamp : nil , timestamp_path : nil , type : &quot;Task&quot; } , &quot;DoLookup&quot; = &gt; % StatesLanguage.Node { branches : [ ] , catch : [ % StatesLanguage.Catch { error_equals : [ :invalid_lookup ] , next : &quot;InvalidLookupError&quot; } , % StatesLanguage.Catch { error_equals : [ :network_error ] , next : &quot;NetworkError&quot; } ] , choices : [ ] , default : nil , event : :success , input_path : &quot;$.:keypad&quot; , is_end : false , items_path : nil , iterator : nil , next : &quot;DispenseNosh&quot; , output_path : &quot;$&quot; , parameters : { :%{} , [ ] , [ { &quot;keyed_input.$&quot; , &quot;$.:input&quot; } ] } , resource : &quot;DoLookup&quot; , resource_path : &quot;$&quot; , seconds : nil , seconds_path : nil , timestamp : nil , timestamp_path : nil , type : &quot;Task&quot; } , &quot;InvalidLookupError&quot; = &gt; % StatesLanguage.Node { branches : [ ] , catch : [ ] , choices : [ ] , default : nil , event : :transition , input_path : &quot;$&quot; , is_end : false , items_path : nil , iterator : nil , next : &quot;ShowError&quot; , output_path : &quot;$&quot; , parameters : { :%{} , [ ] , [ ] } , resource : &quot;SetError:That was not a correct nosh code, please try again&quot; , resource_path : &quot;$&quot; , seconds : nil , seconds_path : nil , timestamp : nil , timestamp_path : nil , type : &quot;Task&quot; } , &quot;NetworkError&quot; = &gt; % StatesLanguage.Node { branches : [ ] , catch : [ ] , choices : [ ] , default : nil , event : :transition , input_path : &quot;$&quot; , is_end : false , items_path : nil , iterator : nil , next : &quot;ShowError&quot; , output_path : &quot;$&quot; , parameters : { :%{} , [ ] , [ ] } , resource : &quot;SetError:Network Error. Please try again&quot; , resource_path : &quot;$&quot; , seconds : nil , seconds_path : nil , timestamp : nil , timestamp_path : nil , type : &quot;Task&quot; } , &quot;ShowError&quot; = &gt; % StatesLanguage.Node { branches : [ ] , catch : [ ] , choices : [ ] , default : nil , event : :transition , input_path : &quot;$&quot; , is_end : false , items_path : nil , iterator : nil , next : &quot;AcceptInput&quot; , output_path : &quot;$&quot; , parameters : { :%{} , [ ] , [ ] } , resource : &quot;DisplayText:error&quot; , resource_path : &quot;$&quot; , seconds : nil , seconds_path : nil , timestamp : nil , timestamp_path : nil , type : &quot;Task&quot; } } , start : &quot;AcceptInput&quot; } The resulting D3Graph serialization looks like this %{ edges : [ %{ source : 0 , target : 2 , type : &quot;%{event: :input_received}&quot; } , %{ source : 2 , target : 1 , type : &quot;:success&quot; } , %{ source : 2 , target : 3 , type : &quot;:invalid_lookup&quot; } , %{ source : 2 , target : 4 , type : &quot;:network_error&quot; } , %{ source : 3 , target : 5 , type : &quot;:transition&quot; } , %{ source : 4 , target : 5 , type : &quot;:transition&quot; } , %{ source : 5 , target : 0 , type : &quot;:transition&quot; } ] , nodes : [ %{ id : 0 , label : &quot;Task&quot; , name : &quot;AcceptInput&quot; } , %{ id : 1 , label : &quot;Task&quot; , name : &quot;DispenseNosh&quot; } , %{ id : 2 , label : &quot;Task&quot; , name : &quot;DoLookup&quot; } , %{ id : 3 , label : &quot;Task&quot; , name : &quot;InvalidLookupError&quot; } , %{ id : 4 , label : &quot;Task&quot; , name : &quot;NetworkError&quot; } , %{ id : 5 , label : &quot;Task&quot; , name : &quot;ShowError&quot; } ] }","ref":"readme.html#serialization"},{"type":"extras","title":"StatesLanguage - Contributing","doc":"Good pull requests - patches, improvements, new features - are a fantastic help. They should remain focused in scope and avoid containing unrelated commits. IMPORTANT : By submitting a patch, you agree that your work will be licensed under the license used by the project. If you have any large pull request in mind (e.g. implementing features, refactoring code, etc), please ask first otherwise you risk spending a lot of time working on something that the project's developers might not want to merge into the project. Please adhere to the coding conventions in the project (indentation, accurate comments, etc.) and don't forget to add your own tests and documentation. When working with git, we recommend the following process in order to craft an excellent pull request: Fork the project, clone your fork, and configure the remotes: # Clone your fork of the repo into the current directory git clone https://github.com/&lt;your-username&gt;/states_language # Navigate to the newly cloned directory cd states_language # Assign the original repo to a remote called &quot;upstream&quot; git remote add upstream https://github.com/citybaseinc/states_language If you cloned a while ago, get the latest changes from upstream, and update your fork: git checkout master git pull upstream master git push Create a new topic branch (off of master ) to contain your feature, change, or fix. IMPORTANT : Making changes in master is discouraged. You should always keep your local master in sync with upstream master and make your changes in topic branches. git checkout -b &lt;topic-branch-name&gt; Commit your changes in logical chunks. Keep your commit messages organized, with a short description in the first line and more detailed information on the following lines. Feel free to use Git's interactive rebase feature to tidy up your commits before making them public. Make sure all the tests are still passing. mix test Push your topic branch up to your fork: git push origin &lt;topic-branch-name&gt; Open a Pull Request with a clear title and description.","ref":"readme.html#contributing"},{"type":"extras","title":"Map and JSONPath","doc":"Map and JSONPath This guide will walk us through using the Map type and JSONPath support to concurrently transform a list of objects to our desired output format. Let's start with our incoming JSON.","ref":"map-and-jsonpath.html"},{"type":"extras","title":"Map and JSONPath - JSON Payload","doc":"{ &quot;client&quot;: &quot;test_client&quot;, &quot;agency&quot;: &quot;test_agency&quot;, &quot;detail&quot;: { &quot;items&quot;: [ { &quot;description&quot;: &quot;Item 1&quot;, &quot;amount&quot;: &quot;$124.65&quot;, &quot;service&quot;: &quot;$3.00&quot;, &quot;name&quot;: &quot;This is item 1&quot; }, { &quot;description&quot;: &quot;Item 2&quot;, &quot;amount&quot;: &quot;$124.65&quot;, &quot;service&quot;: &quot;$3.00&quot;, &quot;name&quot;: &quot;This is item 1&quot; } ] } } Now, let's say we want to transform each of our detail.items to something that looks like this. { &quot;desc&quot;: &quot;Item 1&quot;, &quot;amnt&quot;: 12465, &quot;service_fee&quot;: 300, &quot;title&quot;: &quot;This is item 1&quot; } We'll first start by configuring our state machine to pass the items to a child state machine to handle the transformations.","ref":"map-and-jsonpath.html#json-payload"},{"type":"extras","title":"Map and JSONPath - test/support/states_language_test_mutation.json","doc":"{ &quot;Comment&quot;: &quot;Test map mutations&quot;, &quot;StartAt&quot;: &quot;MapMutation&quot;, &quot;States&quot;: { &quot;MapMutation&quot;: { &quot;Type&quot;: &quot;Map&quot;, &quot;InputPath&quot;: &quot;$.detail&quot;, &quot;ItemsPath&quot;: &quot;$.items&quot;, &quot;Iterator&quot;: &quot;StatesLanguage.TestClientItem&quot;, &quot;ResourcePath&quot;: &quot;$.line_items&quot;, &quot;Next&quot;: &quot;Output&quot; }, &quot;Output&quot;: { &quot;Type&quot;: &quot;Task&quot;, &quot;Resource&quot;: &quot;DoOutput&quot;, &quot;End&quot;: true } } } Here you can see we're telling our interpeter to go into the detail object and that our Items to iterate over are within detail.items . Next we tell the interpeter that we want to use the StatesLanguage.TestClientItem state machine as our Iterator , meaning for each item in our ItemsPath , we will start a new process from the module StatesLanguage.TestClientItem . We'll gather these results and put them into our data at line_items . This way we maintain our original input. Once all processes have finished, we'll move on to our Output state, which in this case will just log our results. Ok, let's have a look at our module for this state machine.","ref":"map-and-jsonpath.html#test-support-states_language_test_mutation-json"},{"type":"extras","title":"Map and JSONPath - test/support/test_client_mutation.ex","doc":"defmodule StatesLanguage.TestClientMutation do @external_resource &quot;test/support/states_language_test_mutation.json&quot; use StatesLanguage , data : &quot;test/support/states_language_test_mutation.json&quot; require Logger @impl true def handle_resource ( &quot;DoOutput&quot; , _ , &quot;Output&quot; , sl ) do Logger . info ( &quot;Line Items: \#{ inspect ( get_in ( sl . data , [ &quot;line_items&quot; ] ) ) } &quot; ) { :ok , sl , [ ] } end @impl true def handle_termination ( _ , _ , % StatesLanguage { } = sl ) do items = get_in ( sl . data , [ &quot;line_items&quot; ] ) send ( sl . data . test , { :line_items , items } ) :ok end end We don't have to do much here, as most of the work is going to be done by our Iterator module. We handle our DoOutput resource, and because this is also a test fixture, we'll send a message back to our test process letting it know the results as well. Ok, on to our Iterator module. First, let's look at our JSON for the state machine.","ref":"map-and-jsonpath.html#test-support-test_client_mutation-ex"},{"type":"extras","title":"Map and JSONPath - test/support/test_client_item.json","doc":"{ &quot;Comment&quot;: &quot;Mutate TestClient Items&quot;, &quot;StartAt&quot;: &quot;Mutate&quot;, &quot;States&quot;: { &quot;Mutate&quot;: { &quot;Type&quot;: &quot;Task&quot;, &quot;Resource&quot;: &quot;DoMutate&quot;, &quot;Parameters&quot;: { &quot;desc.$&quot;: &quot;$.description&quot;, &quot;amnt.$&quot;: &quot;$.amount&quot;, &quot;service_fee.$&quot;: &quot;$.service&quot;, &quot;title.$&quot;: &quot;$.name&quot; }, &quot;End&quot;: true } } } Here we can see some of the cool things we can do with the JSONPath support and Parameters . Any key that ends with &quot;.$&quot; within our Parameters block, tells the interpeter that the value is going to be a JSONPath, and to use the key before the &quot;.$&quot; as the key name. This allows us to transform our incoming data to a totally new format. Now this is pretty cool, but we also wanted to transform our monetary amounts into integers. The original data has all monetary values as strings prepended with the &quot;$&quot; sign, and a &quot;.&quot; separating dollars and cents. So we'll need to write some code to make that happen. Let's see our iterator module to see how to handle that.","ref":"map-and-jsonpath.html#test-support-test_client_item-json"},{"type":"extras","title":"Map and JSONPath - test/support/test_client_item.ex","doc":"defmodule StatesLanguage.TestClientItem do @external_resource &quot;test/support/test_client_item.json&quot; use StatesLanguage , data : &quot;test/support/test_client_item.json&quot; require Logger @impl true def handle_resource ( &quot;DoMutate&quot; , %{ &quot;amnt&quot; = &gt; a , &quot;service_fee&quot; = &gt; sf } = params , &quot;Mutate&quot; , data ) do params = params |&gt; Map . put ( &quot;amnt&quot; , convert_to_integer ( a ) ) |&gt; Map . put ( &quot;service_fee&quot; , convert_to_integer ( sf ) ) Logger . debug ( &quot;New params: \#{ inspect ( params ) } &quot; ) send ( data . _parent , { :task_processed , params , self ( ) } ) { :ok , data , [ ] } end defp convert_to_integer ( amount ) do amount |&gt; String . replace ( &quot;$&quot; , &quot;&quot; ) |&gt; String . replace ( &quot;.&quot; , &quot;&quot; ) |&gt; String . to_integer ( ) end end You can see we're pattern matching on the updated keys for our params. The &quot;Map&quot; type is unique in that it receives a single item as it's params argument after having the Parameters block applied to it's values. So we convert our monetary strings to integers and send the individual result back to our parent state machine. &quot;Parallel&quot; and &quot;Map&quot; types listen for a special message of type StatesLanguage.task_processed/0 . You may wonder why we also have to return the pid of ourselves, this is to ensure our results are in the same order as the original list of items. Which is a requirement of the StatesLanguage spec. If you've checked out the StatesLanguage locally you can run this by running $ mix test test/json_mutation_test.exs Hopefully this gives a good background on using the &quot;Map&quot; type and JSONPath support.","ref":"map-and-jsonpath.html#test-support-test_client_item-ex"}]